Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
Botan::Keyed_Filter Class Referenceabstract

`#include <key_filt.h>`

Inheritance diagram for Botan::Keyed_Filter:

## Public Member Functions
virtual bool | attachable ()
virtual void | end_msg ()
virtual Key_Length_Specification | key_spec () const =0
virtual std::string | name () const =0
virtual void | set_iv (const InitializationVector &iv)
virtual void | set_key (const SymmetricKey &key)=0
virtual void | start_msg ()
virtual bool | valid_iv_length (size_t length) const
bool | valid_keylength (size_t length) const
virtual void | write (const uint8_t input[], size_t length)=0

## Protected Member Functions
virtual void | send (const uint8_t in[], size_t length)
void | send (uint8_t in)
void | send (const secure_vector< uint8_t > &in)
void | send (const std::vector< uint8_t > &in)
void | send (const secure_vector< uint8_t > &in, size_t length)
void | send (const std::vector< uint8_t > &in, size_t length)

## Detailed Description

This class represents keyed filters, i.e. filters that have to be fed with a key in order to function.

Definition at line 21 of file key_filt.h.

## Member Function Documentation

virtual bool Botan::Filter::attachable | ( |  | ) |
| inline virtual inherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::SecureQueue, and Botan::DataSink.

Definition at line 52 of file filter.h.

52 { return true; }

virtual void Botan::Filter::end_msg | ( |  | ) |
| inline virtual inherited

Notify that the current message is finished; flush buffers and do end-of-message processing (if any).

Reimplemented in Botan::MAC_Filter, Botan::Hash_Filter, Botan::Base64_Decoder, Botan::Hex_Decoder, Botan::Base64_Encoder, and Botan::Hex_Encoder.

Definition at line 46 of file filter.h.

46 {}

virtual Key_Length_Specification Botan::Keyed_Filter::key_spec | ( |  | ) | const
| pure virtual

Returns
  object describing limits on key size

Implemented in Botan::MAC_Filter, Botan::StreamCipher_Filter, and Botan::Cipher_Mode_Filter.

virtual std::string Botan::Filter::name | ( |  | ) | const
| pure virtual inherited

Returns
  descriptive name for this filter

Implemented in Botan::MAC_Filter, Botan::Hash_Filter, Botan::Fork, Botan::Hex_Decoder, Botan::Base64_Decoder, Botan::DataSink_Stream, Botan::Chain, Botan::StreamCipher_Filter, Botan::Cipher_Mode_Filter, Botan::BitBucket, Botan::Hex_Encoder, Botan::SecureQueue, and Botan::Base64_Encoder.

Referenced by set_iv().

void Botan::Filter::send | ( | const uint8_t | in[],
|  | size_t | length
| ) |  |
| protected virtual inherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 27 of file filter.cpp.

References Botan::Filter::write().

Referenced by Botan::Hex_Encoder::end_msg(), Botan::Base64_Encoder::end_msg(), Botan::Hex_Decoder::end_msg(), Botan::Base64_Decoder::end_msg(), Botan::Hash_Filter::end_msg(), Botan::MAC_Filter::end_msg(), Botan::StreamCipher_Filter::write(), Botan::Hex_Decoder::write(), and Botan::Base64_Decoder::write().

28 {
29 if(!length)
30 return;
31
32 bool nothing_attached = true;
33 for(size_t j = 0; j != total_ports(); ++j)
34 if(m_next[j])
35 {
36 if(m_write_queue.size())
37 m_next[j]->write(m_write_queue.data(), m_write_queue.size());
38 m_next[j]->write(input, length);
39 nothing_attached = false;
40 }
41
42 if(nothing_attached)
43 m_write_queue += std::make_pair(input, length);
44 else
45 m_write_queue.clear();
46 }
Botan::Filter::write
virtual void write(const uint8_t input[], size_t length)=0

void Botan::Filter::send | ( | uint8_t | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 65 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

65 { send(&in, 1); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const secure_vector< uint8_t > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 70 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

70 { send(in.data(), in.size()); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const std::vector< uint8_t > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 75 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

75 { send(in.data(), in.size()); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const secure_vector< uint8_t > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 81 of file filter.h.

82 {
83 send(in.data(), length);
84 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const std::vector< uint8_t > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 90 of file filter.h.

91 {
92 send(in.data(), length);
93 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Keyed_Filter::set_iv | ( | const InitializationVector & | iv | ) |
| virtual

Set the initialization vector of this filter. Note: you should call set_iv() only after you have called set_key()

Parameters

  iv | the initialization vector to use

Reimplemented in Botan::StreamCipher_Filter, and Botan::Cipher_Mode_Filter.

Definition at line 13 of file basefilt.cpp.

References Botan::OctetString::length(), and Botan::Filter::name().

Referenced by Botan::get_cipher().

14 {
15 if(iv.length() != 0)
16 throw Invalid_IV_Length(name(), iv.length());
17 }
Botan::Filter::name
virtual std::string name() const =0

virtual void Botan::Keyed_Filter::set_key | ( | const SymmetricKey & | key | ) |
| pure virtual

Set the key of this filter

Parameters

  key | the key to use

Implemented in Botan::MAC_Filter, Botan::StreamCipher_Filter, and Botan::Cipher_Mode_Filter.

Referenced by Botan::get_cipher().

virtual void Botan::Filter::start_msg | ( |  | ) |
| inline virtual inherited

Start a new message. Must be closed by end_msg() before another message can be started.

Definition at line 40 of file filter.h.

40 {}

virtual bool Botan::Keyed_Filter::valid_iv_length | ( | size_t | length | ) | const
| inline virtual

Check whether an IV length is valid for this filter

Parameters

  length | the IV length to be checked for validity

Returns
  true if the IV length is valid, false otherwise

Reimplemented in Botan::StreamCipher_Filter, and Botan::Cipher_Mode_Filter.

Definition at line 57 of file key_filt.h.

58 { return (length == 0); }

bool Botan::Keyed_Filter::valid_keylength | ( | size_t | length | ) | const
| inline

Check whether a key length is valid for this filter

Parameters

  length | the key length to be checked for validity

Returns
  true if the key length is valid, false otherwise

Definition at line 42 of file key_filt.h.

43 {
44 return key_spec().valid_keylength(length);
45 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::Keyed_Filter::key_spec
virtual Key_Length_Specification key_spec() const =0

virtual void Botan::Filter::write | ( | const uint8_t | input[],
|  | size_t | length
| ) |  |
| pure virtual inherited

Write a portion of a message to this filter.

Parameters

  input | the input as a byte array
  length | the length of the byte array input

Implemented in Botan::MAC_Filter, Botan::Hash_Filter, Botan::Base64_Decoder, Botan::Fork, Botan::Hex_Decoder, Botan::DataSink_Stream, Botan::StreamCipher_Filter, Botan::Chain, Botan::Hex_Encoder, Botan::Base64_Encoder, Botan::BitBucket, and Botan::SecureQueue.

Referenced by Botan::Filter::send(), and Botan::Pipe::write().

The documentation for this class was generated from the following files:

- src/lib/filters/key_filt.h
- src/lib/filters/basefilt.cpp